## mingw-w64-qt6-declarative-6.8.1-1.src.tar.zst

=== src/qmlcompiler/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## QmlCompilerPrivate Module:
#####################################################################

qt_internal_add_module(QmlCompiler
        PLUGIN_TYPES qmllint
    SOURCES
        qcoloroutput_p.h qcoloroutput.cpp
        qdeferredpointer_p.h
        qqmljsannotation.cpp qqmljsannotation_p.h
        qqmljsbasicblocks.cpp qqmljsbasicblocks_p.h
        qqmljscodegenerator.cpp qqmljscodegenerator_p.h
        qqmljscompilepass_p.h
        qqmljscompiler.cpp qqmljscompiler_p.h
        qqmljscompilerstats.cpp qqmljscompilerstats_p.h
        qqmljscompilerstatsreporter.cpp qqmljscompilerstatsreporter_p.h
        qqmljsfunctioninitializer.cpp qqmljsfunctioninitializer_p.h
        qqmljsimporter.cpp qqmljsimporter_p.h
        qqmljsimportvisitor.cpp qqmljsimportvisitor_p.h
        qqmljsliteralbindingcheck.cpp qqmljsliteralbindingcheck_p.h
        qqmljsvaluetypefromstringcheck.cpp qqmljsvaluetypefromstringcheck_p.h
        qqmljsloadergenerator.cpp qqmljsloadergenerator_p.h
        qqmljslogger_p.h qqmljslogger.cpp
        qqmljsloggingutils.h qqmljsloggingutils.cpp qqmljsloggingutils_p.h
        qqmljsmetatypes_p.h qqmljsmetatypes.cpp
        qqmljsoptimizations_p.h qqmljsoptimizations.cpp
        qqmljsregistercontent.cpp qqmljsregistercontent_p.h
        qqmljsresourcefilemapper.cpp qqmljsresourcefilemapper_p.h
        qqmljsscope.cpp qqmljsscope_p.h
        qqmljsscopesbyid_p.h
        qqmljscontextualtypes_p.h
        qqmljsshadowcheck.cpp qqmljsshadowcheck_p.h
        qqmljsstoragegeneralizer.cpp qqmljsstoragegeneralizer_p.h
        qqmljstypedescriptionreader.cpp qqmljstypedescriptionreader_p.h
        qqmljstypepropagator.cpp qqmljstypepropagator_p.h
        qqmljstypereader.cpp qqmljstypereader_p.h
        qqmljstyperesolver.cpp qqmljstyperesolver_p.h
        qresourcerelocater.cpp qresourcerelocater_p.h
        qqmljsutils_p.h qqmljsutils.cpp
        qqmljslinter_p.h qqmljslinter.cpp
        qqmljslintercodegen_p.h qqmljslintercodegen.cpp
        qqmlsa_p.h qqmlsa.h qqmlsa.cpp
        qqmlsaconstants.h
        qqmlsasourcelocation.h qqmlsasourcelocation.cpp qqmlsasourcelocation_p.h
    NO_UNITY_BUILD_SOURCES
        qqmljsoptimizations.cpp
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::Qml
    LIBRARIES
        Qt::QmlPrivate
        Qt::QmlToolingSettingsPrivate
    PRIVATE_MODULE_INTERFACE
        Qt::QmlPrivate
        Qt::QmlToolingSettingsPrivate
)

qt_path_join(qml_build_dir "${QT_BUILD_DIR}" "${INSTALL_QMLDIR}")
qt_internal_add_resource(QmlCompiler "builtins"
    PREFIX
        "/qt-project.org/qml/builtins"
    BASE
        "${qml_build_dir}"
    FILES
        "${qml_build_dir}/builtins.qmltypes"
        "${qml_build_dir}/jsroot.qmltypes"
)

qt_internal_add_docs(QmlCompiler
    doc/qtqmlcompiler.qdocconf
)

=== src/quicktemplates/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## QuickTemplates2 Module:
#####################################################################

qt_internal_add_qml_module(QuickTemplates2
    URI "QtQuick.Templates"
    VERSION "${PROJECT_VERSION}"
    CLASS_NAME QtQuickTemplates2Plugin
    DEPENDENCIES
        QtQuick/auto
    PLUGIN_TARGET qtquicktemplates2plugin
    NO_PLUGIN_OPTIONAL
    NO_GENERATE_PLUGIN_SOURCE
    SOURCES
        qquickabstractbutton.cpp qquickabstractbutton_p.h
        qquickabstractbutton_p_p.h
        qquickaction.cpp qquickaction_p.h
        qquickactiongroup.cpp qquickactiongroup_p.h
        qquickapplicationwindow.cpp qquickapplicationwindow_p.h
        qquickbusyindicator.cpp qquickbusyindicator_p.h
        qquickbutton.cpp qquickbutton_p.h
        qquickbutton_p_p.h
        qquickbuttongroup.cpp qquickbuttongroup_p.h
        qquickcheckbox.cpp qquickcheckbox_p.h
        qquickcheckdelegate.cpp qquickcheckdelegate_p.h
        qquickcontentitem.cpp qquickcontentitem_p.h
        qquickcontrol.cpp qquickcontrol_p.h
        qquickcontrol_p_p.h
        qquickdeferredexecute.cpp
        qquickdeferredexecute_p_p.h
        qquickdeferredpointer_p_p.h
        qquickdelaybutton.cpp qquickdelaybutton_p.h
        qquickdial.cpp qquickdial_p.h
        qquickdrawer.cpp qquickdrawer_p.h
        qquickdrawer_p_p.h
        qquickframe.cpp qquickframe_p.h
        qquickframe_p_p.h
        qquickgroupbox.cpp qquickgroupbox_p.h
        qquickicon.cpp qquickicon_p.h
        qquickindicatorbutton_p.cpp qquickindicatorbutton_p.h
        qquickitemdelegate.cpp qquickitemdelegate_p.h
        qquickitemdelegate_p_p.h
        qquicklabel.cpp qquicklabel_p.h
        qquicklabel_p_p.h
        qquickmenuseparator.cpp qquickmenuseparator_p.h
        qquicknativeicon_p.h
        qquicknativeicon.cpp
        qquicknativeiconloader_p.h
        qquicknativeiconloader.cpp
        qquicknativemenuitem_p.h
        qquicknativemenuitem.cpp
        qquickoverlay.cpp qquickoverlay_p.h
        qquickoverlay_p_p.h
        qquickpage.cpp qquickpage_p.h
        qquickpage_p_p.h
        qquickpageindicator.cpp qquickpageindicator_p.h
        qquickpane.cpp qquickpane_p.h
        qquickpane_p_p.h
        qquickpopup.cpp qquickpopup_p.h
        qquickpopup_p_p.h
        qquickpopupanchors.cpp qquickpopupanchors_p.h
        qquickpopupanchors_p_p.h
        qquickpopupitem.cpp
        qquickpopupitem_p_p.h
        qquickpopuppositioner.cpp
        qquickpopuppositioner_p_p.h
        qquickpopupwindow.cpp
        qquickpopupwindow_p_p.h
        qquickpresshandler.cpp
        qquickpresshandler_p_p.h
        qquickprogressbar.cpp qquickprogressbar_p.h
        qquickradiobutton.cpp qquickradiobutton_p.h
        qquickradiodelegate.cpp qquickradiodelegate_p.h
        qquickrangeslider.cpp qquickrangeslider_p.h
        qquickroundbutton.cpp qquickroundbutton_p.h
        qquickscrollbar.cpp qquickscrollbar_p.h
        qquickscrollbar_p_p.h
        qquickscrollindicator.cpp qquickscrollindicator_p.h
        qquickscrollview.cpp qquickscrollview_p.h
        qquickshortcutcontext.cpp
        qquickshortcutcontext_p_p.h
        qquickslider.cpp qquickslider_p.h
        qquickspinbox.cpp qquickspinbox_p.h
        qquickstackelement.cpp
        qquickstackelement_p_p.h
        qquickstackview.cpp qquickstackview_p.cpp qquickstackview_p.h
        qquickstackview_p_p.h
        qquickswipe_p.h
        qquickswipedelegate.cpp qquickswipedelegate_p.h
        qquickswipedelegate_p_p.h
        qquickswitch.cpp qquickswitch_p.h
        qquickswitchdelegate.cpp qquickswitchdelegate_p.h
        qquicktabbutton.cpp qquicktabbutton_p.h
        qquicktextarea.cpp qquicktextarea_p.h
        qquicktextarea_p_p.h
        qquicktextfield.cpp qquicktextfield_p.h
        qquicktextfield_p_p.h
        qquicktheme.cpp qquicktheme_p.h
        qquicktheme_p_p.h
        qquicktoolbar.cpp qquicktoolbar_p.h
        qquicktoolbutton.cpp qquicktoolbutton_p.h
        qquicktoolseparator.cpp qquicktoolseparator_p.h
        qquicktooltip.cpp qquicktooltip_p.h
        qquickvelocitycalculator.cpp
        qquickvelocitycalculator_p_p.h
        qtquicktemplates2global.cpp qtquicktemplates2global_p.h
    NO_UNITY_BUILD_SOURCES
        qquickpopupitem.cpp # redefinition of 'contentItemName' (from qquickcontrol.cpp)
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_CAST_TO_ASCII
    INCLUDE_DIRECTORIES
        ${CMAKE_CURRENT_SOURCE_DIR}
    LIBRARIES
        Qt::CorePrivate
        Qt::GuiPrivate
        Qt::QmlPrivate
        Qt::QuickPrivate
    PUBLIC_LIBRARIES
        Qt::Core
        Qt::Gui
        Qt::Quick
    )

qt_internal_extend_target(QuickTemplates2 CONDITION TARGET Qt::QmlModels
    LIBRARIES
        Qt::QmlModelsPrivate
    PUBLIC_LIBRARIES
        Qt::QmlModels
    PRIVATE_MODULE_INTERFACE
        Qt::QmlModelsPrivate
)

qt_internal_extend_target(QuickTemplates2 CONDITION QT_FEATURE_accessibility
    SOURCES
        accessible/qaccessiblequickpage.cpp accessible/qaccessiblequickpage_p.h
)

qt_internal_extend_target(QuickTemplates2 CONDITION QT_FEATURE_quicktemplates2_container
    SOURCES
    qquickcontainer.cpp qquickcontainer_p.h
    qquickcontainer_p_p.h
    qquickdialog.cpp qquickdialog_p.h
    qquickdialog_p_p.h
    qquickdialogbuttonbox.cpp qquickdialogbuttonbox_p.h
    qquickdialogbuttonbox_p_p.h
    qquickmenubar.cpp qquickmenubar_p.h
    qquickmenubar_p_p.h
    qquickmenubaritem.cpp qquickmenubaritem_p.h
    qquickmenubaritem_p_p.h
    qquicksplitview.cpp qquicksplitview_p.h
    qquickswipeview.cpp qquickswipeview_p.h
    qquicktabbar.cpp qquicktabbar_p.h
)

qt_internal_extend_target(QuickTemplates2 CONDITION QT_FEATURE_qml_object_model
    SOURCES
        qquickmenu.cpp qquickmenu_p.h
        qquickmenu_p_p.h
        qquickmenuitem.cpp qquickmenuitem_p.h
        qquickmenuitem_p_p.h
)

qt_internal_extend_target(QuickTemplates2 CONDITION QT_FEATURE_quick_tableview
    SOURCES
        qquickheaderview.cpp qquickheaderview_p.h
        qquickheaderview_p_p.h
        qquickselectionrectangle.cpp qquickselectionrectangle_p.h
        qquickselectionrectangle_p_p.h
)

qt_internal_extend_target(QuickTemplates2 CONDITION QT_FEATURE_quick_treeview
    SOURCES
        qquicktreeviewdelegate.cpp qquicktreeviewdelegate_p.h
)

qt_internal_extend_target(QuickTemplates2 CONDITION QT_FEATURE_quick_listview AND QT_FEATURE_quick_pathview
    SOURCES
        qquicktumbler.cpp qquicktumbler_p.h
        qquicktumbler_p_p.h
)

qt_internal_extend_target(QuickTemplates2 CONDITION QT_FEATURE_quicktemplates2_calendar
    SOURCES
        qquickcalendar.cpp qquickcalendar_p.h
        qquickcalendarmodel.cpp qquickcalendarmodel_p.h
        qquickdayofweekmodel.cpp qquickdayofweekmodel_p.h
        qquickdayofweekrow.cpp qquickdayofweekrow_p.h
        qquickmonthgrid.cpp qquickmonthgrid_p.h
        qquickmonthmodel.cpp qquickmonthmodel_p.h
        qquickweeknumbercolumn.cpp qquickweeknumbercolumn_p.h
        qquickweeknumbermodel.cpp qquickweeknumbermodel_p.h
)

qt_internal_extend_target(QuickTemplates2 CONDITION QT_FEATURE_quick_viewtransitions
    SOURCES
        qquickstacktransition.cpp
        qquickstacktransition_p_p.h
)

qt_internal_extend_target(QuickTemplates2 CONDITION QT_FEATURE_qml_delegate_model
    SOURCES
        qquickcombobox.cpp
        qquickcombobox_p.h
)

qt_internal_extend_Target(qtquicktemplates2plugin
    SOURCES
        qtquicktemplates2plugin.cpp
    LIBRARIES
        Qt::Quick
        Qt::QuickTemplates2Private
)

=== src/imports/tooling/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(qml_files
    "Component.qml"
    "Enum.qml"
    "Member.qml"
    "Method.qml"
    "Module.qml"
    "Parameter.qml"
    "Property.qml"
    "Signal.qml"
)

set_source_files_properties(${qml_files} PROPERTIES
    QT_QML_SOURCE_VERSIONS "1.2;6.0"
)

qt_internal_add_qml_module(quicktooling
    URI "QtQuick.tooling"
    NO_SYNC_QT
    VERSION "${PROJECT_VERSION}"
    NO_PLUGIN_OPTIONAL
    PLUGIN_TARGET quicktooling
    PAST_MAJOR_VERSIONS 1
    QML_FILES ${qml_files}
)

=== tests/auto/qml/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qml.pro.


qt_exclude_tool_directories_from_default_target(
    qmlplugindump
)

add_subdirectory(registrationmacros)
add_subdirectory(parserstress)
add_subdirectory(linebylinelex)
add_subdirectory(qjsprimitivevalue)
add_subdirectory(qjsvalueiterator)
add_subdirectory(qjsonbinding)
add_subdirectory(qqmlfile)

if(NOT INTEGRITY)
    # The INTEGRITY linker tends to crash on tst_qqmlfileselector and tst_qml_common
    add_subdirectory(qqmlfileselector)
    add_subdirectory(common)
endif()

# Limit set of tests to run for static Qt builds.
if(QT_BUILD_MINIMAL_STATIC_TESTS)
    return()
endif()

add_subdirectory(qqmlcomponent)
add_subdirectory(qqmlconsole)
add_subdirectory(qqmlengine)
add_subdirectory(qqmlerror)
add_subdirectory(qqmlincubator)
add_subdirectory(qqmlinfo)
add_subdirectory(qqmllistreference)
if(QT_FEATURE_qml_locale)
    add_subdirectory(qqmllocale)
endif()
add_subdirectory(qqmlmetaobject)
if(NOT ANDROID) # QTBUG-100003
    add_subdirectory(qqmlmoduleplugin)
endif()
add_subdirectory(qqmlnotifier)
add_subdirectory(qqmlqt)
add_subdirectory(qqmlxmlhttprequest)
add_subdirectory(qqmlpromise)
add_subdirectory(qtqmlmodules)
add_subdirectory(qquickfolderlistmodel)
add_subdirectory(qqmlapplicationengine)
if(QT_FEATURE_settings)
    add_subdirectory(qqmlsettings)
endif()

if(NOT INTEGRITY)
# There's no mounted filesystem on INTEGRITY therefore skipping qmldiskcache
    add_subdirectory(qmldiskcache)
endif()

add_subdirectory(qqmlmetatype)
if(TARGET Qt::Quick)
    add_subdirectory(qmltc_manual)
    # QML type compiler tests cannot be run on webOS due to missing support for multiple
    # consecutive window creation from a single QtWayland client
    if(NOT WEBOS)
        add_subdirectory(qmltc)
    endif()
    # This test always creates static plugins. To avoid linker command line
    # ordering issues, we need at least CMake 3.21 and we cannot include the
    # test if qmlimportscanner is being built as part of the main project.
    if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.21 AND
        (QT_BUILD_STANDALONE_TESTS OR QT6_IS_SHARED_LIBS_BUILD))
        add_subdirectory(qmlbasicapp)
    endif()
    if(NOT CMAKE_CROSSCOMPILING)
        add_subdirectory(qqmljsscope)
    endif()
endif()
add_subdirectory(qmlsplitlib)
if(TARGET Qt::Widgets)
    add_subdirectory(qjsengine)
    add_subdirectory(qjsvalue)
    add_subdirectory(qjsmanagedvalue)
    add_subdirectory(qwidgetsinqml)
endif()
if(QT_FEATURE_process AND QT_FEATURE_qml_debug)
    add_subdirectory(debugger)
endif()
if(QT_FEATURE_process AND NOT CMAKE_CROSSCOMPILING)
    add_subdirectory(qmlformat)
    add_subdirectory(qmlimportscanner)
    add_subdirectory(qmllint)
    add_subdirectory(qmltc_qprocess)
    add_subdirectory(qmlplugindump)
    add_subdirectory(qml)
endif()
if(QT_FEATURE_library)
    add_subdirectory(qqmlextensionplugin)
endif()
if(QT_FEATURE_private_tests)
    add_subdirectory(qqmlcpputils)
    add_subdirectory(qqmldirparser)
    if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.19" AND QT_FEATURE_process)
        # Calls qt6_target_qml_sources() directly, which needs CMake 3.19+
        add_subdirectory(qmlcachegen)
    endif()
    add_subdirectory(qmlcppcodegen)
    add_subdirectory(animation)
    add_subdirectory(qqmlecmascript)
    add_subdirectory(qqmlanybinding)
    add_subdirectory(qqmlcontext)
    add_subdirectory(qqmlexpression)
    add_subdirectory(qqmlglobal)
    add_subdirectory(qqmllanguage)
    add_subdirectory(qqmlopenmetaobject)
    add_subdirectory(qqmlproperty)
    add_subdirectory(qqmlpropertycache)
    add_subdirectory(qqmlpropertymap)
# special case begin
    if (TARGET Qt::Sql)
# special case end
        add_subdirectory(qqmlsqldatabase)
# special case begin
    endif()
# special case end
    add_subdirectory(qqmlvaluetypes)
    add_subdirectory(qqmlvaluetypeproviders)
    add_subdirectory(qqmlbinding)
    add_subdirectory(qqmlchangeset)
    add_subdirectory(qqmlconnections)
    add_subdirectory(qqmllistcompositor)
    add_subdirectory(qqmllistmodel)
    add_subdirectory(qqmllistmodelworkerscript)
    add_subdirectory(qqmlitemmodels)
    add_subdirectory(qqmltypeloader)
    add_subdirectory(qqmlparser)
    add_subdirectory(qquickworkerscript)
    add_subdirectory(qrcqml)
    add_subdirectory(qqmltimer)
    add_subdirectory(qqmlinstantiator)
    add_subdirectory(qqmlenginecleanup)
    add_subdirectory(qqmltranslation)
    add_subdirectory(qqmlimport)
    add_subdirectory(qqmlobjectmodel)
    add_subdirectory(qqmltablemodel)
    add_subdirectory(qqmltreemodeltotablemodel)
    add_subdirectory(qv4assembler)
    add_subdirectory(qv4mm)
    add_subdirectory(qv4estable)
    add_subdirectory(qv4identifiertable)
    add_subdirectory(qv4regexp)
    add_subdirectory(qv4urlobject)
    if(QT_FEATURE_process AND NOT QNX AND NOT
        (ANDROID AND CLANG AND
          CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "14.0.0" AND
          CMAKE_CXX_COMPILER_VERSION VERSION_LESS "15.0.0"))
        add_subdirectory(ecmascripttests)
    endif()
    add_subdirectory(bindingdependencyapi)
    add_subdirectory(v4misc)
    add_subdirectory(qqmldelegatemodel) # special case
    if (QT_FEATURE_qml_xmllistmodel)
        add_subdirectory(qqmlxmllistmodel)
    endif()
endif()
if(NOT CMAKE_CROSSCOMPILING)
    add_subdirectory(qmltyperegistrar)
    add_subdirectory(qqmljsutils)
endif()

=== examples/quickcontrols/chattutorial/chapter4/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(chapter4 LANGUAGES CXX)

find_package(Qt6 REQUIRED COMPONENTS Core Gui Qml Quick Sql)

qt_standard_project_setup(REQUIRES 6.8)

qt_add_executable(chattutorial-chapter4 WIN32 MACOSX_BUNDLE
    main.cpp
    sqlcontactmodel.cpp sqlcontactmodel.h
    sqlconversationmodel.cpp sqlconversationmodel.h
)

target_link_libraries(chattutorial-chapter4 PRIVATE
    Qt6::Core
    Qt6::Gui
    Qt6::Qml
    Qt6::Quick
    Qt6::Sql
)

qt_policy(SET QTP0001 NEW)
qt_add_qml_module(chattutorial-chapter4
    URI chattutorial
    QML_FILES
        "ContactPage.qml"
        "ConversationPage.qml"
        "Main.qml"
    RESOURCES
        "images/Albert_Einstein.png"
        "images/Albert_Einstein@2x.png"
        "images/Albert_Einstein@3x.png"
        "images/Albert_Einstein@4x.png"
        "images/Ernest_Hemingway.png"
        "images/Ernest_Hemingway@2x.png"
        "images/Ernest_Hemingway@3x.png"
        "images/Ernest_Hemingway@4x.png"
        "images/Hans_Gude.png"
        "images/Hans_Gude@2x.png"
        "images/Hans_Gude@3x.png"
        "images/Hans_Gude@4x.png"
)

qt6_add_resources(chattutorial-chapter4 "conf"
    PREFIX
        "/"
    FILES
        "qtquickcontrols2.conf"
)

install(TARGETS chattutorial-chapter4
    BUNDLE  DESTINATION .
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

qt_generate_deploy_qml_app_script(
    TARGET chattutorial-chapter4
    OUTPUT_SCRIPT deploy_script
    MACOS_BUNDLE_POST_BUILD
    NO_UNSUPPORTED_PLATFORM_ERROR
    DEPLOY_USER_QML_MODULES_ON_UNSUPPORTED_PLATFORM
)
install(SCRIPT ${deploy_script})

=== src/plugins/qmltooling/qmldbg_local/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qmldbg_local.pro.

#####################################################################
## QLocalClientConnectionFactory Plugin:
#####################################################################

qt_internal_add_plugin(QLocalClientConnectionFactoryPlugin
    OUTPUT_NAME qmldbg_local
    CLASS_NAME QLocalClientConnectionFactory
    PLUGIN_TYPE qmltooling
    SOURCES
        qlocalclientconnection.cpp
    LIBRARIES
        Qt::QmlPrivate
)

#### Keys ignored in scope 1:.:.:qmldbg_local.pro:<TRUE>:
# OTHER_FILES = "$$PWD/qlocalclientconnection.json"

=== src/quickcontrols/macos/impl/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(qml_files
    "CheckIndicator.qml"
    "SwitchHandle.qml"
    "SwitchIndicator.qml"
)

qt_internal_add_qml_module(QuickControls2MacOSStyleImpl
    URI "QtQuick.Controls.macOS.impl"
    VERSION "${PROJECT_VERSION}"
    PAST_MAJOR_VERSIONS 6
    CLASS_NAME QtQuickControls2macOSStyleImplPlugin
    DEPENDENCIES
        QtQuick/auto
    PLUGIN_TARGET qtquickcontrols2macosstyleimplplugin
    QML_FILES
        ${qml_files}
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_CAST_TO_ASCII
)

=== src/quickcontrols/windows/impl/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(qml_files
    "CheckIndicator.qml"
    "SwitchIndicator.qml"
)

qt_internal_add_qml_module(QuickControls2WindowsStyleImpl
    URI "QtQuick.Controls.Windows.impl"
    VERSION "${PROJECT_VERSION}"
    PAST_MAJOR_VERSIONS 6
    CLASS_NAME QtQuickControls2WindowsStyleImplPlugin
    DEPENDENCIES
        QtQuick/auto
    PLUGIN_TARGET qtquickcontrols2windowsstyleimplplugin
    QML_FILES
        ${qml_files}
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_CAST_TO_ASCII
)

=== tests/auto/cmake/test_generate_qmlls_ini/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.19)
project(tst_generate_qmlls_ini)

find_package(Qt6 REQUIRED COMPONENTS Core Qml Test)

qt_standard_project_setup(REQUIRES 6.8)

qt_add_executable(tst_generate_qmlls_ini main.cpp)
target_link_libraries(tst_generate_qmlls_ini PRIVATE Qt6::Test)

set(QT_QML_GENERATE_QMLLS_INI ON CACHE BOOL "" FORCE)

add_subdirectory(SomeSubfolder)
add_subdirectory(Dotted)
add_subdirectory(Dependency)
add_subdirectory(ModuleWithDependency)

qt_add_qml_module(tst_generate_qmlls_ini
    URI MainModule
    VERSION 1.0
    NO_RESOURCE_TARGET_PATH
    SOURCES
        main.cpp
    QML_FILES
        Main.qml
)
target_compile_definitions(tst_generate_qmlls_ini
    PRIVATE
        "SOURCE_DIRECTORY=u\"${CMAKE_CURRENT_SOURCE_DIR}\"_s"
        "BUILD_DIRECTORY=u\"${CMAKE_CURRENT_BINARY_DIR}\"_s"
)

qt_add_qml_module(Module
    URI Module
    VERSION 1.0
    QML_FILES
        Main.qml
    OUTPUT_DIRECTORY ./qml/hello/subfolders/Module
)

# Ensure linting runs when building the default "all" target
set_target_properties(all_qmllint PROPERTIES EXCLUDE_FROM_ALL FALSE)

=== tests/auto/qml/ecmascripttests/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_ecmascripttests Test:
#####################################################################

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_ecmascripttests LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

# Collect test data
file(GLOB_RECURSE test_data_glob
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    test262/*)
list(APPEND test_data ${test_data_glob})
list(FILTER test_data EXCLUDE REGEX ".git")

qt_internal_add_test(tst_ecmascripttests
    SOURCES
        test262runner.cpp test262runner.h
        tst_ecmascripttests.cpp
    LIBRARIES
        Qt::QmlPrivate
        Qt::QuickTestUtilsPrivate
    TESTDATA
        ${test_data}

    # We're doing our own QTest timeout handling here.
    # Don't let ctest interfere.
    TIMEOUT 3600
)

if(ANDROID OR IOS)
    qt_add_resources(tst_ecmascripttests "testExpectations"
        PREFIX
            "/"
        FILES
            "TestExpectations"
    )

    qt_internal_extend_target(tst_ecmascripttests
        DEFINES
            QT_QMLTEST_DATADIR=":/test262"
    )
else()
    qt_internal_extend_target(tst_ecmascripttests
        DEFINES
            QT_QMLTEST_DATADIR="${CMAKE_CURRENT_SOURCE_DIR}/test262"
    )
endif()

=== tests/auto/qml/qmltyperegistrar/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qmltyperegistrar.pro.

#####################################################################
## tst_qmltyperegistrar Test:
#####################################################################

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qmltyperegistrar LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

add_subdirectory(VersionZero)
add_subdirectory(UnregisteredTypes)
add_subdirectory(foreign)
add_subdirectory(Namespaced)

qt_manual_moc(moc_files OUTPUT_MOC_JSON_FILES json_list noextheader
              TARGETS Qt6::Qml)

# Dummy target to pass --private-includes to qmltyperegistrar for tst_qmltyperegistrar.
# We want to test that it expects files named foo_p.h appearing in foreign metatypes
# to be in a private/ subdirectory. In particular, we have a foreign_p.h to exercise this.
# TODO: There should be more fine grained control over this.
qt_add_library(tst_qmltyperegistrarPrivate STATIC
    dummy.cpp dummy_p.h
)

target_link_libraries(tst_qmltyperegistrarPrivate PRIVATE Qt::Core)

qt_internal_add_test(tst_qmltyperegistrar
    SOURCES
        hppheader.hpp
        typereferencinganother.h
        # noextheader special case
        tst_qmltyperegistrar.cpp tst_qmltyperegistrar.h
        foo.cpp foo.h duplicatedExports.h
        inaccessible/base.h
        inaccessible/property.h
        ${moc_files}
    INCLUDE_DIRECTORIES
        foreign
        Namespaced                               # for namespaced.h
        "${CMAKE_CURRENT_BINARY_DIR}/Namespaced" # for the export header
    LIBRARIES
        # Remove: Lforeign
        Qt::Qml
        foreign
        tst_qmltyperegistrarPrivate
        Qt::QmlTypeRegistrarPrivate
        tst_qmltyperegistrar_major_version_zero
        tst_qmltyperegistrar_namespaced_module
        UnregisteredTypes
)

qt_internal_extend_target(tst_qmltyperegistrar CONDITION TARGET Qt::Quick
    LIBRARIES
        Qt::Quick
    )

#### Keys ignored in scope 2:.:.:tst_qmltyperegistrar.pro:<TRUE>:
# QMLTYPES_FILENAME = "tst_qmltyperegistrar.qmltypes"
# QML_FOREIGN_METATYPES = "foreign/foreign_metatypes.json"
# QML_IMPORT_NAME = "QmlTypeRegistrarTest"
# QML_IMPORT_VERSION = "1.0"
# QML_PAST_MAJOR_VERSIONS = "0"
# TEMPLATE = "app"

## Scopes:
#####################################################################

# Simulate conditions that qt6_add_qml_module() would normally set up for us
set_target_properties(tst_qmltyperegistrar PROPERTIES
    QT_QML_MODULE_VERSION 1.1
    QT_QML_MODULE_PAST_MAJOR_VERSIONS 0
    QT_QML_MODULE_URI QmlTypeRegistrarTest
    QT_QML_MODULE_TYPEINFO tst_qmltyperegistrar.qmltypes
    QT_QML_MODULE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

# qt6_add_qml_module() doesn't allow us to pass through MANUAL_MOC_JSON_FILES
# yet, so we have to call it directly to test that code path for now.
_qt_internal_qml_type_registration(tst_qmltyperegistrar MANUAL_MOC_JSON_FILES ${json_list})

qt_add_library(tst-qmltyperegistrar-with-dashes)
qt_autogen_tools_initial_setup(tst-qmltyperegistrar-with-dashes)
target_link_libraries(tst-qmltyperegistrar-with-dashes PRIVATE Qt::Core Qt::Qml)
qt_enable_autogen_tool(tst-qmltyperegistrar-with-dashes "moc" ON)

qt_policy(SET QTP0001 NEW)

qt_add_qml_module(tst-qmltyperegistrar-with-dashes
    URI Module-With-Dashes
    SOURCES
        foo.cpp foo.h
    OUTPUT_DIRECTORY Module-With-Dashes
)
qt_autogen_tools_initial_setup(tst-qmltyperegistrar-with-dashesplugin)

qt_internal_add_resource(tst_qmltyperegistrar "resources"
    PREFIX
        "/"
    FILES
        brokenEnums.json
        duplicatedExports.json
        missingTypes.json
)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
qt_add_library(tst-qmltyperegistrar-enum-foreign STATIC enum.cpp)
qt_autogen_tools_initial_setup(tst-qmltyperegistrar-enum-foreign)
qt_enable_autogen_tool(tst-qmltyperegistrar-enum-foreign "moc" ON)
target_link_libraries(tst-qmltyperegistrar-enum-foreign PRIVATE Qt::QmlIntegration)

qt_add_library(tst-qmltyperegistrar-enum STATIC)
qt_autogen_tools_initial_setup(tst-qmltyperegistrar-enum)
qt_enable_autogen_tool(tst-qmltyperegistrar-enum "moc" ON)
target_link_libraries(tst-qmltyperegistrar-enum PRIVATE Qt::Qml tst-qmltyperegistrar-enum-foreign)

qt_add_qml_module(tst-qmltyperegistrar-enum URI TstEnum OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/TstEnum)
qt_autogen_tools_initial_setup(tst-qmltyperegistrar-enumplugin)
qt_generate_foreign_qml_types(tst-qmltyperegistrar-enum-foreign tst-qmltyperegistrar-enum)

=== tests/auto/qml/qqmlbinding/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qqmlbinding.pro.

#####################################################################
## tst_qqmlbinding Test:
#####################################################################

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qqmlbinding LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

# Collect test data
file(GLOB_RECURSE test_data_glob
    RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
    data/*)
list(APPEND test_data ${test_data_glob})

qt_internal_add_test(tst_qqmlbinding
    SOURCES
        tst_qqmlbinding.cpp
        WithBindableProperties.h
    LIBRARIES
        Qt::CorePrivate
        Qt::Gui
        Qt::GuiPrivate
        Qt::QmlPrivate
        Qt::QmlMetaPrivate
        Qt::QuickPrivate
        Qt::QuickTestUtilsPrivate
    TESTDATA ${test_data}
)

qt_internal_add_test(tst_qqmlbinding_no_deferred_properties
    SOURCES
        tst_qqmlbinding.cpp
        WithBindableProperties.h
    LIBRARIES
        Qt::CorePrivate
        Qt::Gui
        Qt::GuiPrivate
        Qt::QmlPrivate
        Qt::QmlMetaPrivate
        Qt::QuickPrivate
        Qt::QuickTestUtilsPrivate
    TESTDATA ${test_data}
    DEFINES
        QML_DISABLE_INTERNAL_DEFERRED_PROPERTIES
)

set_target_properties(tst_qqmlbinding PROPERTIES
    QT_QML_MODULE_URI "test"
    QT_QML_MODULE_VERSION 1.0
)

_qt_internal_qml_type_registration(tst_qqmlbinding)

set_target_properties(tst_qqmlbinding_no_deferred_properties PROPERTIES
    QT_QML_MODULE_URI "test"
    QT_QML_MODULE_VERSION 1.0
)

_qt_internal_qml_type_registration(tst_qqmlbinding_no_deferred_properties)


qt_internal_extend_target(tst_qqmlbinding CONDITION ANDROID OR IOS
    DEFINES
        QT_QMLTEST_DATADIR=":/data"
)

qt_internal_extend_target(tst_qqmlbinding CONDITION NOT ANDROID AND NOT IOS
    DEFINES
        QT_QMLTEST_DATADIR="${CMAKE_CURRENT_SOURCE_DIR}/data"
)

qt_internal_extend_target(tst_qqmlbinding_no_deferred_properties CONDITION ANDROID OR IOS
    DEFINES
        QT_QMLTEST_DATADIR=":/data"
)

qt_internal_extend_target(tst_qqmlbinding_no_deferred_properties CONDITION NOT ANDROID AND NOT IOS
    DEFINES
        QT_QMLTEST_DATADIR="${CMAKE_CURRENT_SOURCE_DIR}/data"
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-declarative
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.8.1
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Classes for QML and JavaScript languages (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtdeclarative.git"
msys2_references=(
  'archlinux: qt6-declarative'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-languageserver"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        001-appending-qt6-to-remove-qt5-conflict.patch)
sha256sums=('95d15d5c1b6adcedb1df6485219ad13b8dc1bb5168b5151f2f1f7246a4c039fc'
            'b08b7a9cd263eaa2f09ec1b7718d79c253b4e30f3a1f47df6c89fa2e85d7659d')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd $srcdir/${_pkgfn}

  apply_patch_with_msg \
    001-appending-qt6-to-remove-qt5-conflict.patch
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    ../${_pkgfn}

  PATH=$PWD/bin:$PATH ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-declarative() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
              "${MINGW_PACKAGE_PREFIX}-qt6-languageserver")
  conflicts=("${MINGW_PACKAGE_PREFIX}-qt6-quickcontrols2")
  replaces=("${MINGW_PACKAGE_PREFIX}-qt6-quickcontrols2")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs ${pkgdir}/.${MINGW_PREFIX} ${srcdir}/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-declarative-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  conflicts=("${MINGW_PACKAGE_PREFIX}-qt6-quickcontrols2-debug")
  replaces=("${MINGW_PACKAGE_PREFIX}-qt6-quickcontrols2-debug")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf ${srcdir}/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
